//+------------------------------------------------------------------+
//|                                                   TrendMagic.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int    Magic          = 111; //   
extern int    StopLoss       = 0;
extern int    TakeProfit     = 0;
extern int    TrailingStop   = 20;
extern double Lot            = 0.1;

int total, Ticket, day, Min_Dist;
double Price, LT, SL, TP;
string Symb, Text;
bool answer;

double   Mas_Ord[31][13];   //  
int      Mas_Tip[6];            //  .    // []  : 0=B,1=S,2=BL,3=SL,4=BS,5=SS
int      Mas_Tip_T[6];          //  .    -  
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   Symb = Symbol();    //  ..
   Min_Dist = MarketInfo(Symb,MODE_STOPLEVEL); //   -/-  
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   total = OrdersTotal(); //    
   Orders(); //    
   double trm = iCustom(NULL,0,"TrendMagic",0,1); //    TrendMagic
   trm = NormalizeDouble(trm,Digits);
   double trm1 = iCustom(NULL,0,"TrendMagic",1,1); //    TrendMagic
   trm1 = NormalizeDouble(trm1,Digits);
   if((trm < 1000000 && trm1 > 1000000) && (Mas_Tip[1] > 0)) Closing(1); //     TrendMagic  - 
   if((trm > 1000000 && trm1 < 1000000) && (Mas_Tip[0] > 0)) Closing(0); //     TrendMagic  - 
   if(total > 0 && TrailingStop > 0) Trailing(); //   
//-----------------------------------
   if(total == 0 && (trm > 1000000 && trm1 < 1000000)) //  TrendMagic   
    {
     Price = NormalizeDouble(Bid, Digits); //        
     if(StopLoss > 0)
      {
       SL = Price + StopLoss*Point; //  
       SL = NormalizeDouble(SL, Digits); //        
      }
       else SL = 0;
     if(TakeProfit > 0)
      {
       TP = Price - TakeProfit*Point; //  
       TP = NormalizeDouble(TP, Digits); //        
      }
       else TP = 0;
     if(((SL - Price) > Min_Dist*Point || (SL == 0)) && ((Price - TP) > Min_Dist*Point || (TP == 0)))
      {//  .  -  , -, -
       Send(1); //  -  (Sell)
       return(0); //   start()
      }
    }
//-------------------------------
   if((total == 0) && (trm < 1000000 && trm1 > 1000000)) //  TrendMagic   
    {
     Price = NormalizeDouble(Ask, Digits); //        
     if(StopLoss > 0)
      {
       SL = Price - StopLoss*Point; //  
       SL = NormalizeDouble(SL, Digits); //        
      }
       else SL = 0;
     if(TakeProfit > 0)
      {
       TP = Price + TakeProfit*Point; //  
       TP = NormalizeDouble(TP, Digits); //        
      }
       else TP = 0;
     if(((Price - SL) > Min_Dist*Point || (SL == 0)) && ((TP - Price) > Min_Dist*Point || (TP == 0)))
      {//  .  -  , -, -
       Send(0); //  -  (Buy)
       return(0); //   start()
      }
    }
   return(0); //   start()
  }
//+------------------------------------------------------------------+
//                                             |
//+------------------------------------------------------------------+
int Send(int tip)
 {
  LT = Lot(); //    
  if(LT == -1) return(0); //  - Lot()  -1        -   start()
  if(tip == 1)
   {
    Text = "Sell"; //   inf...         .
    inf(1, Ticket, -1); //   ...     Sell 
    Ticket = OrderSend(Symb,OP_SELL,LT,Price,3,SL,TP,NULL,Magic,0,Red); //  
    if(Ticket > 0) //  Ticket  0    ... Ticket   
     { //   
      inf(2, Ticket, -1); //   ...     Sell  
      return(1); //   start()
     }
    inf(15, GetLastError()); //      ...   
    return(0); //   start()
   }
  if(tip == 0)
   {
    Text = "Buy"; //   inf...         .
    inf(1, Ticket, -1); //   ...     Buy 
    Ticket = OrderSend(Symb,OP_BUY,LT,Price,3,SL,TP,NULL,Magic,0,Blue); // 
    if(Ticket > 0) //  Ticket  0    ... Ticket   
     { //   
      inf(2, Ticket, -1); //   ...     Buy  
      return(1); //   start()
     }
    inf(15, GetLastError()); //      ...   
    return(0); //   start()
   }
  return(0); //   start()
 }
//+------------------------------------------------------------------+
//                                               |
//+------------------------------------------------------------------+
int Closing(int tip) //     -    
 {
  for(int i = 0; i < total; i ++) //  
   {
    if(OrderSelect(i, SELECT_BY_POS) == false) continue; //    ,    
    if(Magic != OrderMagicNumber()) continue;//        Magic -    
    Ticket = OrderTicket(); //   
    if(OrderType() == tip)
     {
      Text ="Sell"; //   inf...         .
      RefreshRates();
      Price = NormalizeDouble(Ask,Digits);//MarketInfo(Symb,MODE_ASK);
      LT = OrderLots();
      inf(5, Ticket, -1); //   ...     Sell 
      answer = OrderClose(Ticket,LT,Price,7,Violet);
      if(answer == true) //  true    
       { //   
        inf(6, Ticket, -1); //   ...     Sell  
        return(1); //   start()
       }
      inf(15, GetLastError()); //      ...   
      return(0); //   start()
     }
    if(OrderType() == tip)
     {
      Text ="Buy"; //   inf...         .
      RefreshRates();
      Price = NormalizeDouble(Bid,Digits);//MarketInfo(Symb,MODE_BID);
      LT = OrderLots();
      inf(5, Ticket, -1); //   ...     Buy 
      answer = OrderClose(Ticket,LT,Price,7,Violet);
      if(answer == true) //  true    
       { //   
        inf(6, Ticket, -1); //   ...     Buy  
        return(1); //   start()
       }
      inf(15, GetLastError()); //      ...   
      return(0); //   start()
     }
   } //  
  return(0);
 }
//+------------------------------------------------------------------+
//                                                           |
//+------------------------------------------------------------------+
int Trailing()
 {
  for(int i = 0; i < total; i ++) //  
   {
    if(OrderSelect(i, SELECT_BY_POS) == false) continue; //    ,    
    if(Magic != OrderMagicNumber()) continue;//        Magic -    
    Ticket = OrderTicket(); //   
    if((OrderType() == 1) && (OrderOpenPrice() - Ask > TrailingStop*Point) && ((OrderStopLoss() > Ask + TrailingStop*Point) || (OrderStopLoss()==0)))
     {
      if(OrderStopLoss() == NormalizeDouble(Ask + TrailingStop*Point,Digits)) return(0); //     1
      Text ="Sell"; //   inf...         .
      inf(3, Ticket, -1); //   ...     Sell 
      answer = OrderModify(Ticket,OrderOpenPrice(),NormalizeDouble(Ask + TrailingStop*Point,Digits),OrderTakeProfit(),0,Red);
      if(answer == true) //  true    
       { //   
        inf(4, Ticket, -1); //   ...     Sell  
        return(1); //   start()
       }
      inf(15, GetLastError()); //      ...   
      return(0); //   start()
     }
    if((OrderType() == 0) && (Bid - OrderOpenPrice() > TrailingStop*Point) && (OrderStopLoss() < Bid - TrailingStop*Point))
     {
      if(OrderStopLoss() == NormalizeDouble(Bid - TrailingStop*Point,Digits)) return(0); //     1
      Text ="Buy"; //   inf...         .
      inf(3, Ticket, -1); //   ...     Buy 
      answer = OrderModify(Ticket,OrderOpenPrice(),NormalizeDouble(Bid - TrailingStop*Point,Digits),OrderTakeProfit(),0,Blue);
      if(answer == true) //  true    
       { //   
        inf(4, Ticket, -1); //   ...     Buy  
        return(1); //   start()
       }
      inf(15, GetLastError()); //      ...   
      return(0); //   start()
     }
   } //  
  return(0);
 }
//+------------------------------------------------------------------+
//                                                         |
//+------------------------------------------------------------------+
double Lot()
 {
  int q;
  double dLot, Min_Lot, Max_L, One_Lot;
  One_Lot = MarketInfo(Symb,MODE_MARGINREQUIRED);// . 1 
  Min_Lot = MarketInfo(Symb,MODE_MINLOT);// . . 
  Max_L = MarketInfo(Symb,MODE_MAXLOT);// ax. . 
  dLot = Lot;
//---------
  //    ()
//---------  
  if(Min_Lot == 0.1) q = 1;
  if(Min_Lot == 0.01) q = 2;
  dLot = NormalizeDouble(dLot,q); //        
  if(dLot < Min_Lot) dLot = Min_Lot; //      -   
  if(dLot > Max_L) dLot = Max_L;//      -   
  if(dLot*One_Lot > AccountFreeMargin()) //   ..
   {                         // .. . :(
    inf(12,0,dLot);   // ..
    return(-1);       // .. 
   } // 
  return(dLot); //   
 }
//+------------------------------------------------------------------+
//      - ,   .          |
//+------------------------------------------------------------------+
int Orders()//  ... , ,  ,   .
 {
  int Qnt = 0;                          //   
  Qnt = 0;                              //   
  ArrayInitialize(Mas_Ord,0);       //  
  ArrayInitialize(Mas_Tip,0);           //  
  ArrayInitialize(Mas_Tip_T,0);         //  
  for(int i = 0; i < OrdersTotal(); i++)//  .  . 
   {
    if((OrderSelect(i,SELECT_BY_POS) == true) && (OrderSymbol() == Symb))//  .  //..   .
     {
      if(Magic != OrderMagicNumber()) continue;//        Magic -    
      Qnt++;                                            // .          
      Mas_Ord[Qnt][1] = OrderOpenPrice();           //   
      Mas_Ord[Qnt][2] = OrderStopLoss();            //  SL
      Mas_Ord[Qnt][3] = OrderTakeProfit();          //  
      Mas_Ord[Qnt][4] = OrderTicket();              //  
      Mas_Ord[Qnt][5] = OrderLots();                //  
      Mas_Tip[OrderType()]++;                           // .  
      Mas_Ord[Qnt][6] = OrderType();                //  
      Mas_Ord[Qnt][7] = OrderMagicNumber();         //  
      if(OrderComment() == "") Mas_Ord[Qnt][8] = 0; //   
      else Mas_Ord[Qnt][8] = 1;                     //   
      Mas_Ord[Qnt][9] = OrderOpenTime();            //   
      Mas_Ord[Qnt][10] = OrderCloseTime();          //   
      Mas_Ord[Qnt][11] = OrderExpiration();     //       .
      if(day == TimeDayOfYear(OrderOpenTime()))         //    ...
       {
        Mas_Tip_T[OrderType()]++;                       // .  ...  
       }
     }
   }
  Mas_Ord[0][0] = Qnt;                         // . 
  return;
 }
//----------------------------------------------------------------+
//
//----------------------------------------------------------------+
int inf(int Mess_Number, int Number=0, double Value=0.0)
 {
  string Graf_Text;                   //  
  switch(Mess_Number)                 //   
   {  
    case 1:  Graf_Text = StringConcatenate("  ",Text," .  ..");  break;
    case 2:  Graf_Text = StringConcatenate(" ",Text," :  ",Number);           break;
    case 3:  Graf_Text = StringConcatenate("  ",Text," :  ",Number,".  .."); break;
    case 4:  Graf_Text = StringConcatenate(" ",Text,"  :  ",Number);   break;
    case 5:  Graf_Text = StringConcatenate("  ",Text,"   ",Number,".  ..");  break;
    case 6:  Graf_Text = StringConcatenate(" ",Text," :  ",Number);           break;
    case 7:  Graf_Text = StringConcatenate("  ",Text,"   ",Number); break;
    case 8:  Graf_Text = StringConcatenate(" ",Number,"   "); break;
    case 9:  Graf_Text = StringConcatenate("  ",Number);                   break;
    case 10: Graf_Text = StringConcatenate("   ",Number);              break;
    case 11: Graf_Text = StringConcatenate("  : ",Number);       break;
    case 12: Graf_Text = StringConcatenate("    ",DoubleToStr(Value,2)," "); break;
    case 15: switch(Number)                 //    
              {
               case 2: Graf_Text = " .";
                       break;
               case 4: Graf_Text = "  .";
                       if(IsTesting() == false) Sleep(5000); //     - ""  5 .
                       break;
               case 129: Graf_Text = " .";
                         break;
               case 130: Graf_Text = " .";
                         break;
               case 135: Graf_Text = " .";
                         break;
               case 136: Graf_Text = " .   ..";
                         if(IsTesting() == false) Sleep(1); //     - ""  1 .
                         break;
               case 137: Graf_Text = " .";
                         if(IsTesting() == false)Sleep(5000); //     - ""  5 .
                         break;
               case 146: Graf_Text = "  .";
                         if(IsTesting() == false) Sleep(500); //     - ""   .
                         break;
               case 5 :  Graf_Text = "  .";
                         break;
               case 64:  Graf_Text = " .";
                         break;
               case 133: Graf_Text = " ";
                         break;
               case 134: Alert("    .");
                         return(0);                             //   
               default:  Graf_Text = StringConcatenate("  ",Number);
              }
             break;
    default: Graf_Text = StringConcatenate("default ",Mess_Number);
   }
  Alert(Graf_Text);
 }
//+------------------------------------------------------------------+